/*
 *  Teste da Glist
 *  para compilar use: 
 *  	gcc main.c -o testeglist `pkg-config --cflags --libs glib-2.0`
 */
 
//Inclusao da biblioteca glib
//isso e importante para usar o tipo GList que é o foco do nosso estudo
#include <glib.h>

GList * MinhaLista;//Criacao da Lista encadeada

void mostra (gpointer item, gpointer meusdados); //Mostra o item da lista
gint compara(gconstpointer a,gconstpointer b); //Compara duas strings
void remover(gpointer item,gpointer valor); //Remove item
void g_list_remove_em(GList *lista , const gchar *valor); //Remove um item

//Funcao principal do nosso programa de teste
int main (char argc, char **argv) {
  g_print("Teste da Glist\n");

  gint i = 0; //Variável inteira de uso geral
  MinhaLista = NULL; //É importantíssimo que a GList seja iniciada com NULL

  if (argc > 1) { //Verifica se foi passado algum argumento    
  
    for (i = 1 ; i < argc ; i++ ) {//Passa por todos os elementos da lista
      
      //MinhaLista = g_list_append(MinhaLista,(gpointer) argv[i]);  //Adiciona cada um dos elementos no final da lista
      MinhaLista = g_list_insert_sorted(MinhaLista,(gpointer) argv[i],compara);//Insere ordenado
      
    } //for i
    //g_list_foreach(MinhaLista,remover,argv[1]); //Remove todos os itens com texto igual ao primeiro elemento
    g_list_remove_em(MinhaLista,argv[1]); //Remove apenas o primeiro elemento
    //MinhaLista = g_list_remove(MinhaLista,(gconstpointer)"Linux"); //Isso não funciona   

    //Mostra o total de elementos na glist
    g_print("[Total de elementos: %d]\n",g_list_length(MinhaLista));
    //MinhaLista = g_list_sort(MinhaLista,compara); //Ordena a lista
    //MinhaLista = g_list_reverse(MinhaLista);    //Inverte a lista

    g_print("\nLista Ordenada\n");
    g_list_foreach(MinhaLista,mostra,""); //Mostra a lista
    
  } else g_warning("Nenhum item foi passado para lista. A lista esta vazia"); 
  
  g_list_free(MinhaLista); //Libera o espaço alocado pela "MinhaLista"
  
  return 0;
  
}

void mostra (gpointer item, gpointer meusdados){ //Mostra o item da lista
  gchar *texto = (gchar *) item;
  //Executa o que foi prometido ;-)
  g_print(" * %s\n",texto);
}
gint compara(gconstpointer a,gconstpointer b) { //Compara duas strings
  return g_ascii_strncasecmp( (const gchar *) a , (const gchar *) b , 5) ;
}
void remover(gpointer item,gpointer valor) { //Remove item
  if (compara(item,valor) == 0)
    MinhaLista = g_list_remove(MinhaLista,item);
}
void g_list_remove_em(GList *lista , const gchar *valor){ //Remove um item
  lista = g_list_first(lista);
  do
    if (compara(lista->data,valor) == 0) {
      lista = g_list_remove(lista,lista->data);
      break;
    }
  while (lista = g_list_next(lista));
}

